#Various utility functions for implementing BAR algorithm for computing free energy differences between two thermodynamic states

def self_consistent_iteration(u_kln, max_iterations=2000, tol=1.0e-7, dF_guess=0):
    """
    Converge on the free energy difference between two states - BAR implementation

    Parameters
    ----------
    u_kln: shape(k=number of states(2), l=number of states(2), n=iterations (independent samples))
    dF_guess: an initial guess for the free energy difference between two states

    Returns
    ------
    estimate of free energy difference, dF
    estimate of variance, dFerror
    """
